/***********************************************************************/
/*                                                                     */
/*                              Pio (C++)                              */
/*                                                                     */
/*                    Polyglot Input/Output Library                    */
/*                                                                     */
/*               EPI Pomdapi, INRIA Paris - Rocquencourt               */
/*                                                                     */
/*  Copyright 2005-2014 INRIA.                                         */
/*  Institut National de Recherche en Informatique et en Automatique.  */
/*  All rights reserved. This file is distributed only by permission.  */
/*                                                                     */
/*  Estelle Marchand <Estelle.Marchand@inria.fr>                       */
/*                                                                     */
/***********************************************************************/

/* $Id: matrix_type2.hpp,v 1.9 2014/01/10 19:22:09 fclement Exp $ */

#include "elem.hpp"
#include "single_types.hpp"

#ifndef MATRIX_TYPE2_H
#define MATRIX_TYPE2_H

namespace io{

 class Matrix_type2{
    Single_type matrix_type2;
    int m;
    int n;
  public:
    Single_type type() const;
    int n_rows() const {return m;};
    int n_cols() const{return n;};
    Elem<int**> i;
    Elem<boolean**> b;
    Elem<double**> d;
    Elem<string**> s;
    Elem<float_triple**> ft;
    Elem<float_couple**> fc;
    Elem<int_triple**> it;
    Elem<int_couple**> ic;
    Matrix_type2(){matrix_type2=EMPTY;}
    Matrix_type2(int mm,int nn,int** &i);
    Matrix_type2(int mm,int nn,boolean** &b);
    Matrix_type2(int mm,int nn,double** &d);
    Matrix_type2(int mm,int nn,string** &s);
    Matrix_type2(int mm,int nn,float_triple** &ft);
    Matrix_type2(int mm,int nn,float_couple** &fc);
    Matrix_type2(int mm,int nn,int_triple** &it);
    Matrix_type2(int mm,int nn,int_couple** &ic);
   void free();
    virtual ~Matrix_type2();
  };
  
}

#endif
