/***********************************************************************/
/*                                                                     */
/*                               Pio (C)                               */
/*                                                                     */
/*                    Polyglot Input/Output Library                    */
/*                                                                     */
/*               EPI Pomdapi, INRIA Paris - Rocquencourt               */
/*                                                                     */
/*  Copyright 2011-2014 INRIA.                                         */
/*  Institut National de Recherche en Informatique et en Automatique.  */
/*  All rights reserved. This file is distributed only by permission.  */
/*                                                                     */
/*  Bruno Verlyck <Bruno.Verlyck@inria.fr>                             */
/*                                                                     */
/***********************************************************************/

#include "common.h"
#include "debug_io.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int string_cmp (struct string *s1, struct string *s2) {
  if (s1->ssize != s2->ssize)
    return ((int) s1->ssize - (int) s2->ssize);
  return strncmp (s1->str, s2->str, s1->ssize);
}
int sstring_cmp (struct string s1, struct string s2) {
  return string_cmp (&s1, &s2);
}

bool binary_mode = true, report_mode = false, debug_mode = false;

jmp_buf *fail_label = NULL;
const char *failure_msg;

void failwith (const char *msg) {
  if (fail_label) {
    failure_msg = msg;
    longjmp (*fail_label, (int)((long)&fail_label)); /* low bits of & should be enough */
  }
  pio_fatal_error (msg);
}

/* This must be called when the implementation detects an internal incoherency */
/* Uncatchable (as in pio/ocaml)*/
void invalid_argument (const char *msg) {
  pio_fatal_error (msg);
}
